// $ANTLR 2.7.1: "decls.g" -> "DeclParser.java"$


    package de.uka.ilkd.key.parser;

    import java.io.*;
    import antlr.*;
    import de.uka.ilkd.key.logic.*;
    import de.uka.ilkd.key.rule.*;
    import de.uka.ilkd.key.logic.op.*;
    import de.uka.ilkd.key.logic.sort.*;
    import de.uka.ilkd.key.java.visitor.*;
    import java.util.Vector;
    import java.util.HashMap;
    import de.uka.ilkd.key.proof.UseInsteadMap;


import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/** 
 * A parser for signature declarations,
 * i.e. sorts, schema variabls, predicates, functions and heuristics.
 */
public class DeclParser extends antlr.LLkParser
       implements DeclParserTokenTypes
 {

	static final Sort[] AN_ARRAY_OF_SORTS = new Sort[0];

	private Namespace var_ns;
	private Namespace func_ns;
	private Namespace sort_ns;
	private Namespace heur_ns;
	
	// these variables are set if a file is read in step by
	// step. This used when reading in LDTs because of cyclic
	// dependencies.
	protected boolean skip_schemavariables;
	protected boolean skip_functions;
	protected boolean skip_predicates;
	protected boolean skip_sorts;
	protected boolean skip_heuristics;
	
	protected UseInsteadMap useInstead=new UseInsteadMap();


	public DeclParser(TokenStream lexer,
			  String filename,
			  Namespace var_ns,
			  Namespace func_ns,
			  Namespace sort_ns,
			  Namespace heur_ns) {
	    this(lexer);
	    setFilename(filename);
	    this.var_ns = var_ns;
	    this.func_ns = func_ns;
	    this.sort_ns = sort_ns;
	    this.heur_ns = heur_ns;

	    setSkips(false, false, false, false, false);
	}
		
	public Namespace getSorts() {
	    return sort_ns;
	}

	public Namespace functions() {
	    return func_ns;
	}

	public Namespace heuristics() {
	    return heur_ns;
	}

	public Namespace variables() {
	    return var_ns;
	}


	protected int getLine() {
	    int line = -1;
	    try {
		line = LT(0).getLine();
	    } 
	    catch (Exception e) {
		System.err.println("No further token in stream");
	    }
	    return line;
	}   

	protected int getColumn() {
	    int col = -1;
	    try {
		col = LT(0).getColumn();
	    } 
	    catch (Exception e) {
		System.err.println("No further token in stream");
	    }
	    return col;
	}   


        protected void setSkips(boolean svars, boolean funcs, 
				boolean preds, boolean sorts,
				boolean heurs) {
	    skip_schemavariables = svars;
   	    skip_functions  	 = funcs;
	    skip_predicates 	 = preds;
	    skip_sorts 		 = sorts;
	    skip_heuristics 	 = heurs;
	}

	public void parseVariables() 	
	    throws antlr.RecognitionException, antlr.TokenStreamException
	    {
		setSkips(false, true, true, true, true); 
		top();
		setSkips(false, false, false, false, false);	    		
	    }

	public void parseFunctions()
	    throws antlr.RecognitionException, antlr.TokenStreamException

	    {
		setSkips(true, false, true, true, true); 
		top();
		setSkips(false, false, false, false, false);
	    }

	public void parsePredicates()
	    throws antlr.RecognitionException, antlr.TokenStreamException
	    {
		setSkips(true, true, false, true, true); 
		top();
		setSkips(false, false, false, false, false);	    
	    }

	public void parseSorts() 
	    throws antlr.RecognitionException, antlr.TokenStreamException
	    {
		setSkips(true, true, true, false, true); 
		top();
		setSkips(false, false, false, false, false);
	    }

	public void parseHeuristics()
	    throws antlr.RecognitionException, antlr.TokenStreamException
	    {
		setSkips(true, true, true, true, false); 
		top();
		setSkips(false, false, false, false, false);	    
	    }

	public void parseFuncAndPred()
	    throws antlr.RecognitionException, antlr.TokenStreamException
	    {
		setSkips(true, false, false, true, true); 
		top();
		setSkips(false, false, false, false, false);
	    }

    public NamespaceSet namespaces() {
	NamespaceSet ns = new NamespaceSet();
	ns.setVariables(variables());
	ns.setFunctions(functions());
	ns.setSorts(getSorts());
	ns.setHeuristics(heuristics());
	return ns;
    }


protected DeclParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public DeclParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected DeclParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public DeclParser(TokenStream lexer) {
  this(lexer,2);
}

public DeclParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void top() throws RecognitionException, TokenStreamException {
		
		
		decls();
	}
	
	public final void decls() throws RecognitionException, TokenStreamException {
		
		
		{
		_loop4:
		do {
			switch ( LA(1)) {
			case SORTS:
			{
				sort_decls();
				break;
			}
			case SCHEMA:
			{
				schema_var_decls();
				break;
			}
			case PREDICATES:
			{
				pred_decls();
				break;
			}
			case FUNCTIONS:
			{
				func_decls();
				break;
			}
			case HEURISTICS:
			{
				heur_decls();
				break;
			}
			default:
			{
				break _loop4;
			}
			}
		} while (true);
		}
	}
	
	public final void sort_decls() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
			boolean isObjectSort=false;
		
		
		match(SORTS);
		match(LBRACE);
		{
		_loop8:
		do {
			if ((LA(1)==OBJECT||LA(1)==IDENT)) {
				{
				switch ( LA(1)) {
				case OBJECT:
				{
					match(OBJECT);
					isObjectSort=true;
					break;
				}
				case IDENT:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				id = LT(1);
				match(IDENT);
				match(SEMI);
				
							    Name sort_name = new Name(id.getText());
							    if (sort_ns.lookup(sort_name) == null) {
								Sort s;
								if (!isObjectSort) {
									s = new PrimitiveSort(sort_name);
								} else {
							 	     if ("Object".equals(sort_name)) {
								         if (sort_ns.lookup(new Name("Object"))
												      ==null) {
				
										 s = new ObjectSort(sort_name);
									  }
									  s=(Sort)sort_ns.lookup(new Name("Object"));
									} else {
										s = new ObjectSort(sort_name, 
									                 (Sort)sort_ns.lookup
				(new Name("Object")));
									}	
								}
								sort_ns.add(s);
								if (s instanceof NonCollectionSort) {
									NonCollectionSort ns
										= (NonCollectionSort)s;
									sort_ns.add(ns.getSetSort());
									sort_ns.add(ns.getSequenceSort());
									sort_ns.add(ns.getBagSort());
								}
							    }
							
			}
			else {
				break _loop8;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void schema_var_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort s = null;
			boolean makeVariableSV = false;
		
		
		match(SCHEMA);
		match(VARIABLES);
		match(LBRACE);
		{
		_loop22:
		do {
			if ((LA(1)==PROGRAM||LA(1)==FORMULA||LA(1)==IDENT)) {
				makeVariableSV = false;
				{
				switch ( LA(1)) {
				case PROGRAM:
				{
					{
					match(PROGRAM);
					{
					switch ( LA(1)) {
					case STATEMENT:
					{
						match(STATEMENT);
						
												s=ProgramSVSort.STATEMENT;
											
						break;
					}
					case STATEMENTLIST:
					{
						match(STATEMENTLIST);
						
												s=ProgramSVSort.STATEMENTLIST;
											
						break;
					}
					case EXPRESSION:
					{
						match(EXPRESSION);
						
												s=ProgramSVSort.EXPRESSION;
											
						break;
					}
					case EXPRESSIONLIST:
					{
						match(EXPRESSIONLIST);
						
												s=ProgramSVSort.EXPRESSIONLIST;
											
						break;
					}
					case JAVABOOL:
					{
						match(JAVABOOL);
						match(EXPRESSION);
						
												s=ProgramSVSort.BOOLEANEXPRESSION;
											
						break;
					}
					case LEFTHANDSIDE:
					{
						match(LEFTHANDSIDE);
						
												s=ProgramSVSort.LEFTHANDSIDE;
											
						break;
					}
					case FORINIT:
					{
						match(FORINIT);
						
												s=ProgramSVSort.FORINIT;
											
						break;
					}
					case STATEMENTEXPRESSIONLIST:
					{
						match(STATEMENTEXPRESSIONLIST);
						
												s=ProgramSVSort.STATEMENTEXPRESSIONLIST;
											
						break;
					}
					case LABEL:
					{
						match(LABEL);
						
												s=ProgramSVSort.LABEL;
											
						break;
					}
					case TYPE:
					{
						match(TYPE);
						
												s=ProgramSVSort.TYPE;
											
						break;
					}
					case VARIABLE:
					{
						match(VARIABLE);
						
												s=ProgramSVSort.VARIABLE;
											
						break;
					}
					case VARIABLEINIT:
					{
						match(VARIABLEINIT);
						
												s=ProgramSVSort.VARIABLEINIT;
											
						break;
					}
					case NEW:
					{
						match(NEW);
						
												s=ProgramSVSort.NEW;
											
						break;
					}
					case BOOLEANVARIABLE:
					{
						{
						match(BOOLEANVARIABLE);
						}
						
												s=ProgramSVSort.BOOLEANVARIABLE;
											
						break;
					}
					case CATCHFINALLY:
					{
						{
						match(CATCHFINALLY);
						}
						
												s=ProgramSVSort.CATCHFINALLY;
											
						break;
					}
					case METHODREFERENCE:
					{
						{
						match(METHODREFERENCE);
						}
						
												s=ProgramSVSort.METHODREFERENCE;
											
						break;
					}
					case METHODBODY:
					{
						{
						match(METHODBODY);
						}
						
												s=ProgramSVSort.METHODBODY;
											
						break;
					}
					case BRANCHLIST:
					{
						{
						match(BRANCHLIST);
						}
						
												s=ProgramSVSort.BRANCHLIST;
											
						break;
					}
					default:
						if ((LA(1)==SIMPLE) && (LA(2)==EXPRESSION)) {
							match(SIMPLE);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABOOL)) {
							match(SIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVABOOLEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTE)) {
							match(SIMPLE);
							match(JAVABYTE);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVABYTEEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVASHORT)) {
							match(SIMPLE);
							match(JAVASHORT);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVASHORTEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVAINT)) {
							match(SIMPLE);
							match(JAVAINT);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVAINTEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVALONG)) {
							match(SIMPLE);
							match(JAVALONG);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVALONGEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==JAVABYTESHORTINT)) {
							match(SIMPLE);
							match(JAVABYTESHORTINT);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEJAVABYTESHORTINTEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==ANYJAVATYPE)) {
							match(SIMPLE);
							match(ANYJAVATYPE);
							match(EXPRESSION);
							
													s=ProgramSVSort.SIMPLEANYJAVATYPEEXPRESSION;
												
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==EXPRESSION)) {
							match(NONSIMPLE);
							match(EXPRESSION);
							
													s=ProgramSVSort.NONSIMPLEEXPRESSION;
												
						}
						else if ((LA(1)==NONSIMPLE) && (LA(2)==JAVABOOL)) {
							match(NONSIMPLE);
							match(JAVABOOL);
							match(EXPRESSION);
							
													s=ProgramSVSort.NONSIMPLEBOOLEANEXPRESSION;
												
						}
						else if ((LA(1)==SIMPLE) && (LA(2)==LEFTHANDSIDE)) {
							match(SIMPLE);
							match(LEFTHANDSIDE);
							
													s=ProgramSVSort.SIMPLELEFTHANDSIDE;
												
						}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					break;
				}
				case FORMULA:
				{
					match(FORMULA);
					
										s = Sort.FORMULA;
									
					break;
				}
				case IDENT:
				{
					s=sort_id_check(true);
					{
					switch ( LA(1)) {
					case VARIABLES:
					{
						match(VARIABLES);
						makeVariableSV = true;
						break;
					}
					case IDENT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				one_schema_var_decl(s,makeVariableSV);
				{
				_loop21:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						one_schema_var_decl(s,makeVariableSV);
					}
					else {
						break _loop21;
					}
					
				} while (true);
				}
				match(SEMI);
			}
			else {
				break _loop22;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void pred_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			String pred_name;
		
		
		match(PREDICATES);
		match(LBRACE);
		{
		_loop26:
		do {
			if ((LA(1)==IDENT)) {
				pred_name=id();
				argSorts=arg_sorts(!skip_predicates);
				
							    if (!skip_predicates) {
								Name predicate = new Name(pred_name);
								if (func_ns.lookup(predicate) != null) {
								    // throw new AmbigiousDeclException
								    //("predicate "+pred_name+" ", 
								    //getLine(), getColumn());
								} else {
								    Function p = new Function(predicate,
											      Sort.FORMULA, 
											      argSorts);
								    func_ns.add(p);			
								}
							    } 
							
				match(SEMI);
			}
			else {
				break _loop26;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void func_decls() throws RecognitionException, TokenStreamException {
		
		
			Sort[] argSorts;
			Sort retSort;
		String func_name;
		
		
		match(FUNCTIONS);
		match(LBRACE);
		{
		_loop29:
		do {
			if ((LA(1)==IDENT)) {
				retSort=sort_id_check(!skip_functions);
				func_name=id();
				argSorts=arg_sorts(!skip_functions);
				
							    if (!skip_functions) {
				
								Name fct_name = new Name(func_name);
								if (func_ns.lookup(fct_name) != null) {
								    //throw new AmbigiousDeclException
								    //("function "+func_name, 
								    //getLine(), getColumn());
								} else {
								    Function f=new Function(fct_name,
											    retSort, 
											    argSorts);
								    func_ns.add(f);
								}
							    } 
							
				match(SEMI);
			}
			else {
				break _loop29;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final void heur_decls() throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		match(HEURISTICS);
		match(LBRACE);
		{
		_loop36:
		do {
			if ((LA(1)==IDENT)) {
				id = LT(1);
				match(IDENT);
				match(SEMI);
				
							    if (!skip_heuristics) {
								Heuristic h = new Heuristic(new Name(id.getText()));
								heur_ns.add(h);
							    }
							
			}
			else {
				break _loop36;
			}
			
		} while (true);
		}
		match(RBRACE);
	}
	
	public final Sort  sort_id_check(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
			String idtext=(useInstead.get(id.getText()));
					s= (Sort) sort_ns.lookup(new Name(idtext));
					if (checkSort && s == null) {
					    throw 
						new NotDeclException("sort", id, 
								     getFilename());
					}
				
		return s;
	}
	
	public final void one_schema_var_decl(
		Sort s, boolean makeVariableSV
	) throws RecognitionException, TokenStreamException {
		
		Token  id = null;
		
		id = LT(1);
		match(IDENT);
		
				    if (!skip_schemavariables) {
					SchemaVariable v;
					if ( s == Sort.FORMULA ) {
						v = SchemaVariable.createFormulaSV(
								       new Name(id.getText())
								);
					} else if ( s instanceof ProgramSVSort ) {
						v = SchemaVariable.createProgramSV(
								new Name(id.getText())
								,(ProgramSVSort) s
								);
					} else {
						if ( makeVariableSV ) {
							v=SchemaVariable.createVariableSV(
							               new Name(id.getText()), s);
						} else {
							v = SchemaVariable.createTermSV(
								new Name(id.getText()), s);
						}
					}
					var_ns.add(v);
				    }
				
	}
	
	public final String  id() throws RecognitionException, TokenStreamException {
		String name = null;
		
		Token  classID = null;
		Token  nameID = null;
		
		classID = LT(1);
		match(IDENT);
		
					name = classID.getText();
				
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			match(COLON);
			nameID = LT(1);
			match(IDENT);
			
						 name = classID.getText() + 
						        (nameID == null ? "" : 
						        "::" + nameID.getText());
						
			break;
		}
		case SEMI:
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return name;
	}
	
	public final Sort[]  arg_sorts(
		boolean checkSort
	) throws RecognitionException, TokenStreamException {
		Sort[] argSorts = null;
		
		
			Vector args = new Vector();
			Sort s;
		
		
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			s=sort_id_check(checkSort);
			args.add(s);
			{
			_loop33:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					s=sort_id_check(checkSort);
					args.add(s);
				}
				else {
					break _loop33;
				}
				
			} while (true);
			}
			match(RPAREN);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
					argSorts = (Sort[])args.toArray(AN_ARRAY_OF_SORTS);
				
		return argSorts;
	}
	
	public final Sort  sort_id() throws RecognitionException, TokenStreamException {
		Sort s = null;
		
		
		s=sort_id_check(true);
		return s;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"java\"",
		"\"statement\"",
		"\"statementlist\"",
		"\"expression\"",
		"\"expressionlist\"",
		"\"nonsimple\"",
		"\"lefthandside\"",
		"\"simple\"",
		"\"notsimple\"",
		"\"forinit\"",
		"\"typeof\"",
		"\"type\"",
		"\"javaboolean\"",
		"\"object\"",
		"\"javabyte\"",
		"\"javashort\"",
		"\"javaint\"",
		"\"javalong\"",
		"\"javabyteshortint\"",
		"\"anyjavatype\"",
		"\"number\"",
		"\"intliteral\"",
		"\"longliteral\"",
		"\"variable\"",
		"\"booleanvariable\"",
		"\"catchfinally\"",
		"\"methodreference\"",
		"\"methodbody\"",
		"\"variableinitializer\"",
		"\"statementexpressionlist\"",
		"\"label\"",
		"\"program\"",
		"\"all\"",
		"\"ex\"",
		"\"eps\"",
		"\"true\"",
		"\"false\"",
		"\"find\"",
		"\"if\"",
		"\"varcond\"",
		"\"noninteractive\"",
		"\"recursive\"",
		"\"displayname\"",
		"\"helptext\"",
		"\"new\"",
		"\"not\"",
		"\"free\"",
		"\"in\"",
		"\"close\"",
		"\"goal\"",
		"\"replacewith\"",
		"\"add\"",
		"\"addrules\"",
		"\"addprogvars\"",
		"\"heuristics\"",
		"\"sorts\"",
		"\"schema\"",
		"\"variables\"",
		"\"predicates\"",
		"\"functions\"",
		"\"formula\"",
		"\"rules\"",
		"\"branchlist\"",
		"\"proof\"",
		"\"rule\"",
		"\"term\"",
		"\"branch\"",
		"\"problem\"",
		"\"#inType\"",
		"\"#inLong\"",
		"\"#inInt\"",
		"\"#inShort\"",
		"\"#inByte\"",
		"\"#add\"",
		"\"#sub\"",
		"\"#mul\"",
		"\"#div\"",
		"\"#mod\"",
		"\"#less\"",
		"\"#greater\"",
		"\"#leq\"",
		"\"#geq\"",
		"\"#eq\"",
		"\"#JavaIntUnaryMinus\"",
		"\"#JavaIntAdd\"",
		"\"#JavaIntSub\"",
		"\"#JavaIntMul\"",
		"\"#JavaIntDiv\"",
		"\"#JavaIntMod\"",
		"\"#JavaIntAnd\"",
		"\"#JavaIntOr\"",
		"\"#JavaIntXor\"",
		"\"#JavaIntShiftRight\"",
		"\"#JavaIntShiftLeft\"",
		"\"#JavaIntUnsignedShiftRight\"",
		"\"#JavaLongUnaryMinus\"",
		"\"#JavaLongAdd\"",
		"\"#JavaLongSub\"",
		"\"#JavaLongMul\"",
		"\"#JavaLongDiv\"",
		"\"#JavaLongMod\"",
		"\"#JavaLongAnd\"",
		"\"#JavaLongOr\"",
		"\"#JavaLongXor\"",
		"\"#JavaLongShiftRight\"",
		"\"#JavaLongShiftLeft\"",
		"\"#JavaLongUnsignedShiftRight\"",
		"\"#moduloByte\"",
		"\"#moduloShort\"",
		"\"#moduloInteger\"",
		"\"#moduloLong\"",
		"VOCAB",
		"`;'",
		"`/'",
		"`:'",
		"`?='",
		"`/->'",
		"`:='",
		"`.'",
		"`,'",
		"`('",
		"`)'",
		"`{'",
		"`}'",
		"`|'",
		"`&'",
		"`->'",
		"`<->'",
		"`='",
		"`==>'",
		"java operator",
		"white space",
		"a string in double quotes",
		"ESC",
		"DIAMOND",
		"BOX",
		"BLOCK",
		"a string with double quotes",
		"a comment",
		"a comment",
		"a digit",
		"a letter",
		"an admissible character for identifiers",
		"an identifer"
	};
	
	
	}
